package edu.sc.seis.cormorant.network;

import java.sql.SQLException;
import java.util.Properties;
import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.Servant;
import edu.iris.Fissures.IfNetwork.NetworkExplorer;
import edu.iris.Fissures.IfNetwork.NetworkFinder;
import edu.sc.seis.cormorant.DBProvidingAbstractController;
import edu.sc.seis.fissuresUtil.database.network.JDBCChannel;

/**
 * @author crotwell Created on Jan 31, 2005
 */
public class NetworkController extends DBProvidingAbstractController {

    public NetworkController(Properties confProps,
                             String serverPropName,
                             ORB orb) throws Exception {
        super(confProps, serverPropName, orb);
        createNetworkDC(orb);
    }

    public Servant getServant() {
        return networkDCImpl;
    }

    private void createNetworkDC(ORB orb) throws SQLException, Exception {
        JDBCChannel jdbcChannel = new JDBCChannel(dbConnCreator.createConnection());
        POA networkControllerPOA = createPOA(orb);
        NetworkExplorerImpl explorerImpl = new NetworkExplorerImpl(jdbcChannel);
        netLocate = new NetworkServantLocator(jdbcChannel,
                                                                    networkControllerPOA);
        org.omg.PortableServer.ServantManager locator = netLocate._this(orb);
        networkControllerPOA.set_servant_manager(locator);
        NetworkFinderImpl finderImpl = new NetworkFinderImpl(netLocate);
        NetworkExplorer explorer = explorerImpl._this(orb);
        NetworkFinder finder = finderImpl._this(orb);
        networkDCImpl = new NetworkDCImpl(explorer, finder);
    }
    
    public NetworkServantLocator getNetworkServantLocator(){
        return netLocate;
    }

    private NetworkServantLocator netLocate;
    
    private NetworkDCImpl networkDCImpl;
}